﻿using System;
using twitchbot_wpf;
using CirclePrefect.Dotnet;

namespace BasicCommands
{
    [ApiVersion(0, 1)]
    public class Plugin : TwitchBot
    {
        public override Version Version => new Version(1, 0, 0, 0);
        public override string Name => "Basic commands";
        public const string Send = "PRIVMSG #";
        private string Channel
        {
            get { return ChatRoom.Instance.channel; }
        }
        public static DataStore Data;
        private string[] Parameters
        {
            get { return new string[] { "title", "content", "soundfile" }; }
        }
        const string channel = "700hours";
        public override void Initialize()
        {
            Data = new DataStore("command_data");
            ChatRoom.UserCommandEvent += OnCommand;
        }
        public override void Dispose()
        {
            ChatRoom.UserCommandEvent -= OnCommand;
            Data.WriteToFile();
        }

        private void OnCommand(object sender, ChatRoom.CommandEventArgs e)
        {
            //Console.WriteLine(e.Message);
            ChatRoom chat = ChatRoom.Instance;
            string prefix = (Send + channel + " @" + e.User + " :").Normalize();
            string prefix2 = (Send + channel + " :").Normalize();
            string cmd = "";
            string command = e.Message.Substring(1).ToLower().Normalize();

            if (Data.BlockExists(command))
            {
                //Console.WriteLine(e.User + " used " + command + " command.");
                chat.SendMessage(Data.GetBlock(command).GetValue(Parameters[1]));
                return;
            }
            if (channel == e.User)
            {
                if (command.StartsWith("create"))
                {
                    if (!command.Contains(" "))
                    {
                        chat.SendMessage("There is no command title, therefore this command was ignored.");
                        return;
                    }
                    cmd = command.Substring(command.IndexOf(" ") + 1);
                    if (cmd.Contains(" "))
                    {
                        chat.SendMessage("Command title contains a space, therefore this command was ignored.");
                        return;
                    }
                    if (!Data.BlockExists(cmd))
                    {
                        Data.NewBlock(Parameters, cmd);
                        chat.SendMessage("Command [" + cmd + "] made. Now use the command <edit <command name>> to change it's contents.");
                    }
                    else
                    {
                        chat.SendMessage("This command has already been made.");
                    }
                    return;
                }
                else if (command.StartsWith("edit"))
                {
                    if (!command.Contains(" "))
                        return;
                    string[] split = command.Split(' ');
                    if (split.Length < 3)
                    {
                        chat.SendMessage("Command edit using insufficient parameters.");
                        return;
                    }
                    cmd = split[1];
                    //Console.WriteLine(cmd);
                    if (Data.BlockExists(cmd))
                    {
                        Block block = Data.GetBlock(cmd);
                        block.WriteValue(Parameters[1], e.Message.Substring("edit".Length + cmd.Length + 3));
                        chat.SendMessage("Command description modified.");
                    }
                    else
                    {
                        chat.SendMessage("Command does not exist.");
                    }
                }
                else if (command.StartsWith("remove"))
                {
                    cmd = command.Substring(command.IndexOf(" ") + 1);
                    if (cmd.Contains(" "))
                    {
                        chat.SendMessage("Command title contains a space, therefore this command was ignored.");
                        return;
                    }
                    if (!Data.BlockExists(cmd))
                    {
                        chat.SendMessage("Command [" + cmd + "] already does not exist in the database.");
                        return;
                    }
                    else
                    {
                        Block block = Data.GetBlock(cmd);
                        block.WriteValue("title", "");
                        block.WriteValue("content", "");
                        block.WriteValue("soundfile", "");
                        chat.SendMessage("Command [" + cmd + "]'s data has been removed from the database.");
                    }
                }
            }
        }
    }
}
