﻿using System;
using twitchbot_wpf;

using CirclePrefect.Dotnet;

namespace Plugin
{
    [ApiVersion(0, 1)]
    public class Plugin : TwitchBot
    {
        public override Version Version 
        {
            get { return new Version(0, 1); }
        }
        public override string Name
        {
            get { return "Maze Plugin"; } 
        }
		private DataStore data;
        public override void Initialize()
        {
			data = new DataStore("config\\member_data");
            ChatRoom.MessageReceivedEvent += ChatInteraction;
			ChatRoom.UserJoinEvent += UserJoin;
        }
        public override void Dispose()
        {
			data.WriteToFile();
            ChatRoom.MessageReceivedEvent -= ChatInteraction;
			ChatRoom.UserJoinEvent -= UserJoin;
        }

		public void UserJoin(object sender, ChatRoom.JoinEventArgs e)
		{
			if (!data.BlockExists(e.UserName))
			{
				string[] info = new string[] {
					"zenny"
				};
				data.NewBlock(info, e.UserName);
			}
		}

        public void ChatInteraction(object sender, ChatRoom.MessageReceivedArgs e)
		{
            if (e.Message.ToLower().StartsWith(Global.maze))
            {
                Global.chatInteract = "Maze";
                Console.WriteLine("Chat interaction started: " + Global.chatInteract);
                Global.chatEventRunning = true;
            }
            var client = ChatRoom.Instance;
			Global.ticks++;
			if (!(Global.chatInteract == "Maze"))
			{
				return;
			}
			if (!Global.initialize)
			{
				Global.size = Global.rand.Next(3, 6);
				Global.MAZER = new int[Global.size, Global.size];
				Global.zenny = 8 * Global.size;
				Global.energy = 99;
				string message = "Swamp maze has been generated, " + Global.zenny + " zenny in the pot";
				client.SendMessage(message);
				Global.loop = 0;
				while (Global.loop < Global.MAZER.GetLength(0))
				{
					while (Global.point < Global.size)
					{
						for (int i = 0; i < Global.size; i++)
						{
							int num = Global.rand.Next(3);
							Global.MAZER[i, Global.point] = num;
							if (i == Global.size - 1)
							{
								Global.point++;
							}
						}
						if (Global.point == Global.size)
						{
							break;
						}
					}
					Global.loop++;
				}
				Global.startX = Global.rand.Next(Global.size);
				Global.startY = Global.rand.Next(Global.size);
				Global.exitX = Global.rand.Next(Global.size);
				Global.exitY = Global.rand.Next(Global.size);
				Global.MAZER[Global.startX, Global.startY] = 4;
				Global.MAZER[Global.exitX, Global.exitY] = 3;
				Global.ticks = 0;
				Global.initialize = true;
			}
			if (!Global.active && Global.initialize)
			{
				string message2 = "Try to beat this " + Global.size + "x" + Global.size + " swamp maze! Commands are !up, !left, !down & !right";
				client.SendMessage(message2);
				Global.ticks = 0;
				Global.active = true;
			}
			if (!Global.active || Global.loop != Global.size)
			{
				return;
			}
			string text = "Ready to take another step";
			string remainder = ", " + Global.zenny + " Zenny remaining";
			string text2 = "Blocked by the outer wall";
			string neg = "By forcing the way through the mud, energy is lost";
			string neut = "Climbing onto dry land gives freedom from the mud";
			string pos = "There is a wood platform here to give rest";
			string exit = e.UserName + " has found the exit!";
			int num2 = 4;
			for (int j = 0; j < Global.MAZER.GetLength(0); j++)
			{
				for (int k = 0; k < Global.MAZER.GetLength(1); k++)
				{
					if (Global.MAZER[j, k] != 4)
					{
						continue;
					}
					switch (e.Message)
					{
					case "!up":
						if (j == 0)
						{
							client.SendMessage(text2);
							Console.WriteLine(e.UserName + ": " + text2);
							break;
						}
						Global.MAZER[j, k] = 0;
						MazePosition(e, k, j - 1, remainder, neg, neut, pos, exit);
						Global.MAZER[j - 1, k] = num2;
						Global.ticks = 0;
						break;
					case "!left":
						if (k == 0)
						{
							client.SendMessage(text2);
							Console.WriteLine(e.UserName + ": " + text2);
							break;
						}
						Global.MAZER[j, k] = 0;
						MazePosition(e, k - 1, j, remainder, neg, neut, pos, exit);
						Global.MAZER[j, k - 1] = num2;
						Global.ticks = 0;
						break;
					case "!down":
						if (j == Global.size - 1)
						{
							client.SendMessage(text2);
							Console.WriteLine(e.UserName + ": " + text2);
						}
						else if (Global.step)
						{
							Global.MAZER[j, k] = 0;
							MazePosition(e, k, j + 1, remainder, neg, neut, pos, exit);
							Global.MAZER[j + 1, k] = num2;
							Global.ticks = 0;
							Global.step = false;
						}
						break;
					case "!right":
						if (k == Global.size - 1)
						{
							client.SendMessage(text2);
							Console.WriteLine(e.UserName + ": " + text2);
						}
						else if (Global.step)
						{
							Global.MAZER[j, k] = 0;
							MazePosition(e, k + 1, j, remainder, neg, neut, pos, exit);
							Global.MAZER[j, k + 1] = num2;
							Global.ticks = 0;
							Global.step = false;
						}
						break;
					}
				}
			}
			if (!Global.endEvent)
			{
				if (Global.zenny >= 10)
				{
					Global.zenny -= 5;
				}
				Console.WriteLine(text + ", " + Global.zenny + " Zenny remaining");
			}
			Global.step = true;
		}

		public void MazePosition(ChatRoom.MessageReceivedArgs e, int x, int y, string remainder, string neg, string neut, string pos, string exit)
		{
            var client = ChatRoom.Instance;
			if (Global.energy <= 0)
			{
				Global.endEvent = true;
				string message = "Too exhausted to move on, the search ends";
				client.SendMessage(message);
				Reset();
				return;
			}
			string text = "Coordinates [" + x + ", " + y + "], ";
			switch (Global.MAZER[y, x])
			{
			case 0:
				Global.energy -= 10;
				client.SendMessage(text + neg + ", " + Global.energy + " energy left" + remainder);
				Console.WriteLine(e.UserName + ": " + neg + ", " + Global.energy + " energy left");
				break;
			case 1:
				client.SendMessage(text + neut + remainder);
				Console.WriteLine(e.UserName + ": " + neut);
				break;
			case 2:
				if (Global.energy < 94)
				{
					Global.energy += 5;
				}
				client.SendMessage(text + pos + ", " + Global.energy + " energy left" + remainder);
				Console.WriteLine(e.UserName + ": " + pos + ", " + Global.energy + " energy left");
				break;
			case 3:
				Global.endEvent = true;
				client.SendMessage(exit + " " + e.UserName + " gains " + Global.zenny + " zenny");
				Console.WriteLine(exit);
				FinalizeRecord(e.UserName, Global.zenny, "win");
				Reset();
				break;
			}
		}

        public void FinalizeRecord(string victor, int zenny, string source)
		{
			Block block = data.GetBlock(victor);
			int num = int.Parse(block.GetValue("zenny")) + zenny;
			if (!(source == "passive") || num <= 500)
			{
				block.IncreaseValue("zenny", num);
			}
		}

		public void Reset()
		{
			Global.initialize = false;
			Global.active = false;
			Global.point = 0;
			Global.size = 0;
			Global.loop = 0;
			Global.zenny = 0;
			Global.energy = 99;
			Global.endEvent = false;
			Global.chatEventRunning = false;
		}
    }
}
